def dfs(node, visited, adjacency_list):
                visited[node] = True
                for neighbor in adjacency_list[node]:
                                if not visited[neighbor]:
                                                dfs(neighbor, visited, adjacency_list)

def main():
                import sys
                input = sys.stdin.read
                data = input().splitlines()
                first_line = data[0].split()
                n = int(first_line[0])
                m = int(first_line[1])
                adjacency_list = [[]for _ in range(n + 1)]
                for i in range(1, m + 1):
                                a, b = map(int, data[i].split())
                                adjacency_list[a].append(b)
                                adjacency_list[b].append(a) 
                                visited = [False] * (n + 1)
                                components = 0

                for i in range(1, n + 1):
                                if not visited[i]:
                                                dfs(i, visited, adjacency_list)
                                                components += 1
                                print(components)
if __name__ == '__main__':
                main()
